<html><head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>menumaker</title>
    <style type="text/css" media="all">
      @import url("scilab_code.css");
      @import url("xml_code.css");
      @import url("c_code.css");
      @import url("style.css");
    </style>
  </head>
  <body>
    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="inputui.html">&lt;&lt; inputui</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_83de88e7fbbfd10c75a19a537c038964.html">GUI Tools</a></span>

      </td>
      <td width="30%" class="next">
      	
      </td>
    </tr></table>
      <hr />
    </div>



    <span class="path"><a href="index.html">GUI Tools</a> &gt;&gt; <a href="section_83de88e7fbbfd10c75a19a537c038964.html">GUI Tools</a> &gt; menumaker</span>

    <br /><br />
    <div class="info"></div>

  <div class="refnamediv"><h1 class="refname">menumaker</h1><p class="refpurpose">Add menus to a figure</p></div>



<div class="refsynopsisdiv"><h3 class="title">Calling Sequence</h3>
   <div class="synopsis"><pre><span class="default">[</span><span class="default">h_menu</span><span class="default">] = </span><span class="functionid">menumaker</span><span class="default">(</span><span class="default">menus</span><span class="default">[,</span><span class="default">callbackFun</span><span class="default">][,</span><span class="default">f</span><span class="default">][,</span><span class="default">Flag</span><span class="default">])</span>
<span class="default">[</span><span class="default">h_menu</span><span class="default">] = </span><span class="functionid">menumaker</span><span class="default">(</span><span class="default">menus</span><span class="default">) </span><span class="comment">// creates a new figure with menus</span>
<span class="default">[</span><span class="default">h_menu</span><span class="default">] = </span><span class="functionid">menumaker</span><span class="default">(</span><span class="default">menus</span><span class="default">,</span><span class="default">callbackFun</span><span class="default">)  </span><span class="comment">// as above but also with callbackFun('Label') as callback</span></pre></div></div>

<div class="refsection"><h3 class="title">Parameters</h3>
   <dl><dt><span class="term">menus:</span>
      <dd><p class="para">list defining the menus to be added.</p></dd></dt>
   <dt><span class="term">menu:</span>
      <dd><p class="para">element in menus where menu=list(Label,callback,arg1,arg1val,....) or menu=list(Label,submenus)</p></dd></dt>
   <dt><span class="term">Label:</span>
      <dd><p class="para">string with the label name of a menu entry.</p></dd></dt>
   <dt><span class="term">callback:</span>
      <dd><p class="para">string containing the callback of the menu item. If callback=&#0039;&#0039; then callbackFun will be used.</p></dd></dt>
   <dt><span class="term">argn:</span>
      <dd><p class="para">optional relevant arguments like Enable,Checked,ForgroundColor,Tag og Visible. See <a href="scilab://scilab.help/uimenu" class="link">uimenu</a>.</p></dd></dt>
   <dt><span class="term">submenus:</span>
      <dd><p class="para">list defining submenus item in a menu (submenus elements have the same structure as menu)</p></dd></dt>
   <dt><span class="term">callbackFun:</span>
      <dd><p class="para">optional string with the name of the callback function to be called as callbackFun(&#0039;Label&#0039;) if no callback is given for any particular item.</p></dd></dt>
   <dt><span class="term">f:</span>
      <dd><p class="para">optional figure handle. If empty then f=gcf().</p></dd></dt>
   <dt><span class="term">Flag:</span>
      <dd><p class="para">optional Flag=1 remove standard menus, Flag=2 remove Graphics menu or Flag3=remove both.</p></dd></dt>
   <dt><span class="term">h_menu:</span>
      <dd><p class="para">list of handles to the menus. Handles to sub menus are present as lists.</p></dd></dt></dl></div>

<div class="refsection"><h3 class="title">Description</h3>
   <p class="para">menumaker is a tool for adding menus to figures and gui&#0039;s with a minimum of programming.</p>
   <p class="para">The menu structure is defined using nested lists similar to the way
gui&#0039;s are defined in guimaker. See the Parameters section and the examples.</p>
   <p class="para"></p>
   <p class="para"></p></div>

<div class="refsection"><h3 class="title">Examples</h3>
   <div class="programlisting"><table border="0" width="100%"><tr><td width="98%"><pre class="scilabcode"><span class="scilabcomment">// Example from help uimenu</span>
<a class="scilabmacro" href="scilab://scf">scf</a><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">menus</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">windows</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">operations</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">new window</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">show_window()</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">clear window</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">delete(gca())</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">quit scilab</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">exit</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">$\LaTeX$</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">$\int_0^\infty\mathrm{e}^{-x^2}\,dx$</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">$\frac\sqrt{\pi}2$</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">MathML</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">msup</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">mn</span><span class="scilabstring">&#0062;</span><span class="scilabstring">x</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/mn</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">mi</span><span class="scilabstring">&#0062;</span><span class="scilabstring">2</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/mi</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/msup</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">mrow</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">msup</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">mn</span><span class="scilabstring">&#0062;</span><span class="scilabstring">a</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/mn</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">mi</span><span class="scilabstring">&#0062;</span><span class="scilabstring">2</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/mi</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/msup</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">mo</span><span class="scilabstring">&#0062;</span><span class="scilabstring">+</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/mo</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">msup</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">mn</span><span class="scilabstring">&#0062;</span><span class="scilabstring">b</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/mn</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">mi</span><span class="scilabstring">&#0062;</span><span class="scilabstring">2</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/mi</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/msup</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">mo</span><span class="scilabstring">&#0062;</span><span class="scilabstring">=</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/mo</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">msup</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">mn</span><span class="scilabstring">&#0062;</span><span class="scilabstring">c</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/mn</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">mi</span><span class="scilabstring">&#0062;</span><span class="scilabstring">2</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/mi</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/msup</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0060;</span><span class="scilabstring">/mrow</span><span class="scilabstring">&#0062;</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">menumaker</span><span class="scilabopenclose">(</span><span class="scilabid">menus</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">messagebox</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabcomment">//</span>
<span class="scilabcomment">// Example from the demo section GUI - Uicontrol1</span>
<a class="scilabmacro" href="scilab://scf">scf</a><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">menus</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">menus</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Application</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Exit figure</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">close(gcf())</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Quit Scilab</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">quit</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">menus</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Scilab Graphics</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Launch plot3d</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">plot3d()</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Launch plot2d</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">plot2d()</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">menus</span><span class="scilabopenclose">(</span><span class="scilabspecial">$</span><span class="scilaboperator">+</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Menu</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Sub menu 1</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">disp(''''Sub menu 1'''')</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Sub menu 2</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Sub menu 2-1</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">disp(''''Sub menu 2-1'''')</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Sub menu 2-2</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">disp(''''Sub menu 2-2'''')</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span><span class="scilabspecial">...</span>
<a class="scilabcommand" href="scilab://list">list</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Sub menu 3</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">if get(gcbo,''''checked'''')==''''on'''' then set(gcbo,''''checked'''',''''off''''); else set(gcbo,''''checked'''',''''on''''); end</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">menumaker</span><span class="scilabopenclose">(</span><span class="scilabid">menus</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<a class="scilabmacro" href="scilab://demo_viewCode">demo_viewCode</a><span class="scilabopenclose">(</span><span class="scilabstring">&#0039;</span><span class="scilabstring">menumaker2.dem.sce</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span></pre></td><td valign="top"><a href="scilab://scilab.execexample/"><img src="ScilabExecute.png" border="0"/></a></td><td valign="top"><a href="scilab://scilab.editexample/"><img src="ScilabEdit.png" border="0"/></a></td><td></td></tr></table></div></div>

<div class="refsection"><h3 class="title">See also</h3>
   <ul class="itemizedlist"><li class="member"><a href="guimaker.html" class="link">guimaker</a></li>
   <li class="member"><a href="inputui.html" class="link">inputui</a></li></ul></div>

<div class="refsection"><h3 class="title">Authors</h3>
   <ul class="itemizedlist"><li class="member">Torbjørn Pettersen, top@tpett.com</li></ul></div>


    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="inputui.html">&lt;&lt; inputui</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_83de88e7fbbfd10c75a19a537c038964.html">GUI Tools</a></span>

      </td>
      <td width="30%" class="next">
      	
      </td>
    </tr></table>
      <hr />
    </div>
  </body>
</html>
